// AppDlg.h : header file
//

#if !defined(AFX_APPDLG_H__A76DAA4A_4CC7_11D1_A9A1_00A024931610__INCLUDED_)
#define AFX_APPDLG_H__A76DAA4A_4CC7_11D1_A9A1_00A024931610__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define WM_USER_THREAD_TERMINATED (WM_USER +1)

typedef struct {

    HANDLE handle;
    ULONG  ioOperations;
    BOOL   waitForCompletions;
    HWND   hWnd;
    HANDLE completionPort;
    
} THREAD_CONTEXT, *PTHREAD_CONTEXT;

/////////////////////////////////////////////////////////////////////////////
// CAppDlg dialog

class CAppDlg : public CDialog
{
// Construction
public:
	CAppDlg(CWnd* pParent = NULL);	// standard constructor
    ~CAppDlg(); // cleanup this mess

// Dialog Data
	//{{AFX_DATA(CAppDlg)
	enum { IDD = IDD_APP_DIALOG };
	CEdit	m_passEdit;
	CButton	m_exitButton;
	CSpinButtonCtrl	m_spinPasses;
	CEdit	m_threadsEdit;
	CEdit	m_ioEdit;
	CSpinButtonCtrl	m_threadSpin;
	CSpinButtonCtrl	m_ioOpSpinCtrl;
	CButton	m_startIO;
	CButton	m_setState;
	CButton	m_getState;
	CButton	m_startstop;
	BOOL	m_cancelIrp;
	BOOL	m_cancelOn;
	BOOL	m_completeOn;
	int		m_speed;
	int		m_IoOperations;
	UINT	m_queuelen;
	BOOL	m_completeCanceled;
	BOOL	m_earlyRelease;
	int		m_nThreads;
	UINT	m_nPasses;
	DWORD	m_passesComplete;
	DWORD	m_iosCompleted;
	DWORD	m_cancelledIO;
	CString	m_statusMessages;
	BOOL	m_setCancel;
	DWORD	m_apc_complete;
	BOOL	m_unloadDriver;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAppDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation private data
private:

	ULONG threadsStarted;
	THREAD_CONTEXT context;
	CWinThread * workerThread;
    CWinThread * serverThread;
	CANCEL_STATE cancelState;	
	CString cwd;
	BOOL m_userWarned;

    //
    // the driver object.
    //
    ServiceControl * driver;

// Implementation private functions
private:
	void startThreads();
	ULONG completionsExpected;
	
    void deactivateDriverDlg();
	void activateDriverDlg();
    void setThreadControls(BOOLEAN state);

protected:
	HICON m_hIcon;
    afx_msg void OnThreadTerminate(WPARAM result, LPARAM writes);

	// Generated message map functions
	//{{AFX_MSG(CAppDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnStartstop();
	afx_msg void OnGetState();
	afx_msg void OnSetState();
	afx_msg void OnGenerateIo();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_APPDLG_H__A76DAA4A_4CC7_11D1_A9A1_00A024931610__INCLUDED_)
