@echo off
set scriptDebug=0
if "%scriptDebug%" == "0" goto echoOff
@echo on

:echoOff
 
if "%BASEDIR%"=="" goto no_basedir

set path=%path%;%BASEDIR%\bin

if "%1" == "" goto noMode
set mode=%1
shift
if "%mode%" == "freesd" goto setsd
goto callsetenv

:setsd
@echo enabling symbols in free build
set mode=free
pushd .
call %BASEDIR%\bin\setenv.bat %BASEDIR% %mode% "%MSDEV%"
popd

rem reset debugging vars
set NTDEBUGTYPE=windbg
set NTDEBUG=ntsd
goto checkDir

:noMode
set mode=checked

:callsetenv
@echo calling ddk setenv %BASEDIR% %mode% "%MSDEV%"
pushd .
call %BASEDIR%\bin\setenv.bat %BASEDIR% %mode% "%MSDEV%"
popd

:checkDir
if "%1" == "" goto noDir
if EXIST %1 goto dirOK

@echo Error: directory %1 does not exist
goto usage

:noDir
@echo Error: no directory specified
:usage
echo usage: ddkbuild "checked | free" "directory-to-build" [flags] 
echo        set MSDEV environment variable to specify optional compiler path
echo        (for example set MSDEV=C:\MSDEV\BIN) this allows usage of VC5.0 ide
echo        with the VC4.2 compiler back end.
goto end

:dirOK

if "%NUMBER_OF_PROCESSORS"=="" goto no_mp
set mpFlag=-M
goto mp_done

:no_mp
set mpFlag=""

:mp_done

echo build in directory %1 with arguments %2 (basedir %BASEDIR%)

cd %1
set bflags=-e
set bscFlags=""

if "%2" == "" goto noaddflags

set bscFlags=/n

set bflags=%2%e

:noaddflags

:done

if EXIST build.err	erase build.err
if EXIST build.wrn  erase build.wrn
if EXIST build.log	erase build.log

echo run build %bflags% %mpFlag% for %mode% version in %1
pushd .
build  %bflags% %mpFlag%
popd

rem assume that the onscreen errors are complete!

echo =============== build warnings ======================
if not exist build.log goto complete

findstr "warning.*[CLU][0-9]*" build.log

echo. 
echo. 

:complete
echo build complete
goto doBrowse

:no_basedir
@echo Error: BASEDIR not set
goto usage

:doBrowse

echo building browse information files

rem @echo on

if EXIST sbrList.txt goto bscList

goto end

:bscList

if %bscFlags% == "" goto noBscFlags

bscmake %bscFlags% @sbrList.txt

goto end

:noBscFlags

bscmake @sbrList.txt

:end

echo ddkbuild complete
